<template>
  <div class="weather">
    <a-select
      v-model:value="inputCity"
      style="width: 200px"
      ref="select"
      @change="fetchWeather"
    >
      <a-select-option v-for="a in cities" :key="a.value" :value="a.value">{{
        a.label
      }}</a-select-option>
    </a-select>

    <div v-if="data.temperature" class="weather_info">
      <div>{{ data.city }}</div>
      <div>
        <span>{{ data.temperature }}</span>
        <span>{{ " " }}</span>
        <span>{{ data.currentWeatherUnits }}</span>
      </div>
      <div>{{ data.isWindy ? "Windy" : "Calm" }}</div>
    </div>
    <div></div>
  </div>
</template>

<script lang="ts" setup>
import { onBeforeMount, onMounted, ref } from "vue";
import { CITIES } from "@/constants";
import { getWeather } from "@/api";
import type { SelectProps } from "ant-design-vue";

const inputCity = ref("");
let cities = [{ value: "", label: "" }];
const data = ref({
  city: "",
  temperature: null,
  currentWeatherUnits: "",
  isWindy: false,
});

onBeforeMount(async () => {
  cities = getCitiesArray();
});

function getCitiesArray() {
  let arr = [{ value: "", label: "" }];
  for (const city of CITIES) {
    arr.push({
      value: city.city,
      label: city.city,
    });
  }
  return arr;
}
async function fetchWeather() {
  const currentCity = CITIES.find(
    (v) => v.city.toLowerCase() === inputCity.value.toLowerCase()
  );
  console.log("inputCity", inputCity.value);

  if (!currentCity) return;

  const result = await getWeather(currentCity.lat, currentCity.lng);

  data.value.city = inputCity.value;
  data.value.temperature = result?.data?.current_weather?.temperature;
  data.value.currentWeatherUnits =
    result?.data?.current_weather_units?.temperature;
  data.value.isWindy = result?.data?.current_weather?.windspeed > 2;

  return {};
}
</script>

<style lang="scss">
.weather {
  display: flex;
  flex-direction: column;
  height: 50vh;
  justify-content: space-between;

  &_info {
    font-size: 1.5rem;
    font-weight: bold;
    line-height: 2;
  }
}
</style>
